package school_project;

import java.io.Serializable;

/**
 * This is used to represent a position/vector/... any ensemble of 2 elements that have to work together in
 * a plan. This way we can use some basic operations over them.
 */
public class Vec2 implements Serializable {
    public int x, y;

    public Vec2() {
        x = 0;
        y = 0;
    }

    public Vec2(int x, int y ){
        this.x = x;
        this.y = y;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj instanceof Vec2 vec) {
            return this.x == vec.x && this.y == vec.y;
        }
        return false;
    }

    public Vec2 add(Vec2 o){
        return new Vec2(x + o.x, y + o.y);
    }

    public Vec2 sub(Vec2 o){
        return new Vec2(x - o.x, y - o.y);
    }

    @Override
    public String toString() {
        return "("+x+","+y+")";
    }
}
